/**
 * ideal-postcodes-core - Ideal Postcodes core frontend javascript library
 * @version v0.1.3
 * @link https://ideal-postcodes.co.uk/
 * @license MIT
 */

var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},IdealPostcodes;!function(e){e.API_URL="api.ideal-postcodes.co.uk",e.TLS=!0,e.VERSION="v1",e.DEFAULT_TIMEOUT=1e4,e.STRICT_AUTHORISATION=!1}(IdealPostcodes||(IdealPostcodes={})),window.IdealPostcodes=IdealPostcodes;var IdealPostcodes;!function(e){var t;!function(e){e.now=function(){return Date.now()},e.debounce=function(t,r){function o(){var c=e.now()-a;c>0&&c<r?n=setTimeout(o,r-c):(n=null,i=t.apply(u,s),n||(u=s=null))}void 0===r&&(r=100);var n,s,u,a,i;return function(){return u=this,s=arguments,a=e.now(),n||(n=setTimeout(o,r)),i}},e.extend=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];for(var o=t.length,n=0;n<o;n++){var s=t[n];for(var u in s)void 0!==s[u]&&(e[u]=s[u])}return e}}(t=e.Utils||(e.Utils={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t=function(){function e(){this.store={postcodeStore:{},addressStore:{},autocompleteStore:{},udprnStore:{},umprnStore:{}}}return e.prototype.cacheAddressQuery=function(e,t){this.store.addressStore[e]=t},e.prototype.getAddressQuery=function(e){return this.store.addressStore[e]},e.prototype.cachePostcodeQuery=function(e,t){this.store.postcodeStore[e]=t},e.prototype.getPostcodeQuery=function(e){return this.store.postcodeStore[e]},e.prototype.cacheAutocompleteQuery=function(e,t){this.store.autocompleteStore[e]=t},e.prototype.getAutocompleteQuery=function(e){return this.store.autocompleteStore[e]},e.prototype.cacheUdprnQuery=function(e,t){this.store.udprnStore[e]=t},e.prototype.getUdprnQuery=function(e){return this.store.udprnStore[e]},e.prototype.cacheUmprnQuery=function(e,t){this.store.umprnStore[e]=t},e.prototype.getUmprnQuery=function(e){return this.store.umprnStore[e]},e}();e.Cache=t}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(e){e.blankRe=/^\s*$/,e.AllowedAuthorizationParameters=["api_key"],e.detectTls=function(e){try{return"http:"!==e.location.protocol}catch(t){return!0}},e.isIE=function(e){var t=e?e:window.navigator;try{var r=t.userAgent.toLowerCase();return r.indexOf("msie")!==-1&&parseInt(r.split("msie")[1])}catch(o){return!1}},e.generateQueryString=function(e){var t=[];for(var r in e)t.push(encodeURIComponent(r)+"="+encodeURIComponent(e[r]));return t.join("&")},e.constructHeaders=function(t){var r={};return r.Authorization=e.constructAuthenticationHeader(t),r},e.deconstructAuthenticationHeader=function(e){var t={};return e?(e.replace("IDEALPOSTCODES ","").trim().split(" ").forEach(function(e){var r=e.split("=");"string"==typeof r[0]&&"string"==typeof r[1]&&(t[r[0]]=r[1].replace(/(^"|"$)/g,""))}),t):t},e.constructAuthenticationHeader=function(t){for(var r=[],o=0;o<e.AllowedAuthorizationParameters.length;o++){var n=e.AllowedAuthorizationParameters[o];void 0!==t[n]&&r.push(n+'="'+t[n]+'"')}return 0===r.length?"":"IDEALPOSTCODES "+r.join(" ")},e.constructQueryString=function(e){var t={};return e.filter&&(t.filter=e.filter.join(",")),e.licensee&&(t.licensee=e.licensee),e.tags&&(t.tags=e.tags.join(",")),t},e.constructAutocompleteQueryString=function(e){var t={};return t.query=e.query,t},e.constructAddressQueryString=function(e){var t={};return t.query=e.query,t.page=e.page||0,t.limit=e.limit||10,t}}(t=e.Transport||(e.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(e){var t=function(e){function t(t){e.call(this),this.message="Ideal Postcodes Error: "+t.message}return __extends(t,e),t}(Error);e.IdealPostcodesError=t;var r=function(e){function t(){e.call(this,{message:"Unable to parse JSON response"})}return __extends(t,e),t}(t);e.JsonParseError=r}(t=e.Errors||(e.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(e){e.parse=function(t){var o=t.status;if(200!==o){switch(o){case 503:return new r}try{return e.parseErrorResponse(JSON.parse(t.responseText),o)}catch(n){return new e.JsonParseError}}},e.parseErrorResponse=function(e,r){var o=e.code,s=e.message;return void 0===o||void 0===s?new n:new t({responseCode:o,status:r,message:s})};var t=function(e){function t(t){e.call(this,t),t.status&&(this.status=t.status),t.responseCode&&(this.responseCode=t.responseCode)}return __extends(t,e),t}(e.IdealPostcodesError);e.IdealPostcodesApiError=t;var r=function(e){function t(){e.call(this,{status:503,message:"Rate Limit Reached. Please wait a while before you retry your request"})}return __extends(t,e),t}(t);e.RateLimitError=r;var o=function(e){function t(){e.call(this,{message:"Request timed out"})}return __extends(t,e),t}(t);e.RequestTimeoutError=o;var n=function(e){function t(){e.call(this,{message:"Unknown AJAX error occurred when accessing API"})}return __extends(t,e),t}(t);e.GenericApiError=n}(t=e.Errors||(e.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(t){t.getXhr=function(){try{return new(XMLHttpRequest||ActiveXObject)("MSXML2.XMLHTTP.3.0")}catch(e){return null}},t.xhrRequest=function(r,o){var n=r.url,s=t.generateQueryString(r.queryString);s.length>0&&(n+="?"+s);var u=t.getXhr();u.open(r.method,n,!0);try{for(var a in r.headers)u.setRequestHeader(a,r.headers[a])}catch(i){}var c=setTimeout(function(){u.onreadystatechange=function(){},u.abort(),o(new Error("Request timeout"),null,u)},r.timeout);return u.onreadystatechange=function(){var r;if(4===u.readyState){if(clearTimeout(c),200!==u.status)return o(e.Errors.parse(u),{},u);try{r=t.blankRe.test(u.responseText)?{}:JSON.parse(u.responseText)}catch(n){return o(new Error("parsererror"),null,u)}return o(null,r,u)}},u.send(r.data),u}}(t=e.Transport||(e.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(t){var r=0,o=function(){},n=function(r,o){r.queryString.callback=o;var n=r.headers,s=t.deconstructAuthenticationHeader(n.Authorization);return e.Utils.extend(r.queryString,s),t.generateQueryString(r.queryString)},s=function(e){var t=e.code;return t&&"number"==typeof t?parseInt(String(t).slice(0,3)):500};t.jsonpRequest=function(t,u){r+=1;var a=t.url;if(t.method&&"get"!==t.method.toLowerCase())return u(new Error("Browser is unable to perform non-GET requests"),null,null),null;var i="idpc_"+e.Utils.now()+"_"+r,c=n(t,i);c.length>0&&(a+="?"+c);var l=document.getElementsByTagName("script")[0]||document.head,d=setTimeout(function(){p(),u(new Error("Request timeout"),null,null)},t.timeout),p=function(){h.parentNode&&h.parentNode.removeChild(h),window[i]=o,d&&clearTimeout(d)};window[i]=function(t){p();var r=s(t),o={responseText:t,status:r};return 200!==o.status?u(e.Errors.parseErrorResponse(t,r),null,o):u(null,t,o)};var h=document.createElement("script");return h.src=a,h.type="text/javascript",l.parentNode.insertBefore(h,l),null}}(t=e.Transport||(e.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t;!function(t){t.defaultHeaders={Accept:"text/javascript, application/javascript"},t.request=function(r,o){var n={url:r.url,method:r.method||"GET",headers:r.headers||{},queryString:r.queryString||{},timeout:r.timeout||e.DEFAULT_TIMEOUT,data:r.data||null};return e.Utils.extend(n.headers,t.defaultHeaders),t.isIE()&&t.isIE()<10?t.jsonpRequest(n,o):t.xhrRequest(n,o)}}(t=e.Transport||(e.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(e){var t=e.Utils.extend,r=e.Transport,o=r.constructHeaders,n=r.constructQueryString,s=r.constructAddressQueryString,u=r.constructAutocompleteQueryString,a=function(){function r(t){var r=this;void 0===t&&(t={}),this.api_key=t.api_key,this.tls=void 0===t.tls?e.TLS:t.tls,this.version=void 0===t.version?e.VERSION:t.version,this.baseUrl=void 0===t.baseUrl?e.API_URL:t.baseUrl,this.strictAuthorisation=void 0===t.strictAuthorisation?e.STRICT_AUTHORISATION:t.strictAuthorisation,this.cache=new e.Cache;var o=this;this.autocompleteCallback=function(){},this.debouncedAutocomplete=e.Utils.debounce(function(e){r.lookupAutocomplete(e,o.autocompleteCallback)})}return r.prototype.apiUrl=function(){return"http"+(this.tls?"s":"")+"://"+this.baseUrl+"/"+this.version},r.prototype.ping=function(t){e.Transport.request({url:"http"+(this.tls?"s":"")+"://"+this.baseUrl},t)},r.prototype.lookupPostcode=function(t,r){var s=this;t.api_key=this.api_key;var u=o(t),a=n(t),i=t.postcode,c=this.cache.getPostcodeQuery(i);return c?r(null,c):void e.Transport.request({url:this.apiUrl()+"/postcodes/"+encodeURIComponent(t.postcode),headers:u,queryString:a},function(e,t,o){return e&&4040===e.responseCode?r(null,[],o):e?r(e,null,o):(s.cache.cachePostcodeQuery(i,t.result),r(null,t.result,o))})},r.prototype.lookupAddress=function(r,u){var a=this;r.api_key=this.api_key;var i=o(r),c=n(r);t(c,s(r));var l=r.query,d=this.cache.getAddressQuery(l);return d?u(null,d):void e.Transport.request({url:this.apiUrl()+"/addresses",headers:i,queryString:c},function(e,t,r){return e?u(e,null,r):(a.cache.cacheAddressQuery(l,t.result),u(null,t.result,r))})},r.prototype.lookupAutocomplete=function(r,s){var a=this;r.api_key=this.api_key;var i=o(r),c=n(r);t(c,u(r));var l=r.query,d=this.cache.getAutocompleteQuery(l);return d?s(null,d):(this.strictAuthorisation||(c.api_key=this.api_key,delete i.Authorization),void e.Transport.request({url:this.apiUrl()+"/autocomplete/addresses",headers:i,queryString:c},function(e,t,r){return e?s(e,null,r):(a.cache.cacheAutocompleteQuery(l,t.result),s(null,t.result,r))}))},r.prototype.lookupUdprn=function(t,r){var s=this;t.api_key=this.api_key;var u=o(t),a=n(t),i=t.id,c=this.cache.getUdprnQuery(i);return c?r(null,c):void e.Transport.request({url:this.apiUrl()+"/udprn/"+i,headers:u,queryString:a},function(e,t,o){return e?r(e,null,o):(s.cache.cacheUdprnQuery(i,t.result),r(null,t.result,o))})},r.prototype.lookupUmprn=function(t,r){var s=this;t.api_key=this.api_key;var u=o(t),a=n(t),i=t.id,c=this.cache.getUmprnQuery(i);return c?r(null,c):void e.Transport.request({url:this.apiUrl()+"/umprn/"+i,headers:u,queryString:a},function(e,t,o){return e?r(e,null,o):(s.cache.cacheUmprnQuery(i,t.result),r(null,t.result,o))})},r.prototype.checkKeyUsability=function(t){e.Transport.request({url:this.apiUrl()+"/keys/"+this.api_key},function(e,r,o){return e?t(e,null,o):t(null,r.result,o)})},r.prototype.autocompleteAddress=function(e){this.debouncedAutocomplete(e)},r.prototype.registerAutocompleteCallback=function(e){this.autocompleteCallback=e},r}();e.Client=a}(IdealPostcodes||(IdealPostcodes={}));